/*
 * RT6_VIN  written by mira308sw
 *
 * script to read/write user_com.dat file from usb device and update VIN
 * in DB boot.
 *
 * WARNING:
 * VIN code must me written in the file user_config.dat and also in the
 * line #define VIN "1234567890123457"  below, before run this script.
 *
 * v01.00 : 03/11/2012
 */

#define VIN           "12345678901234567"   // VIN number to write

#define DBSYSTEM_FILE "/bd0/dbsystem.bin"
#define FLASH_DIR     "/F/user_data/User_profile"
#define RTX_DIR       "/SDI/user_data/User_profile"
#define USB_DIR       "/bd0"
#define DAT_FILE      "/User_config.dat"
#define INF_FILE      DAT_FILE ".inf"
#define NO            0
#define YES           1
#define OK            0
#define ERROR        -1

int     GetFileSize (char* file, int* size);
int     ShowNavigationQuestionScreen (char* text, int* answer);
int     UPGCopy ( char *src,char *dst,int cut );
void    RebootSystem ( void );
void*   UPGFindSymbol ( char *sym );
int     AddUPGHistoryCommentary	 ( void *funptr,... );   // max 7 parameters
#define GFC           AddUPGHistoryCommentary


void  BackupDBSystem ( void )
{
  int   answ;
  void  *fp=UPGFindSymbol( "BackupDBSystem__FPCc" );
  if( !fp )
    ShowNavigationQuestionScreen( "Error in FindSymbol(BackupDBSystem)",&answ );
  else
  {
    if( GFC( fp,DBSYSTEM_FILE )!=OK )
      ShowNavigationQuestionScreen( "Error in BackupDBSystem(file)",&answ );
  }
}

void SetSBSystemCodeVIN ( void )
{
  int   answ;
  void *pf=UPGFindSymbol( "InterSetSBSystemCodeVIN__FPCUc" );
  if( !pf )
    ShowNavigationQuestionScreen( "Error in UPGFindSymbol(InterSetSBSystemCodeVIN)",&answ );
  else
  {
    if( GFC( pf,VIN )!=OK )
      ShowNavigationQuestionScreen( "Error in InterSetSBSystemCodeVIN(vin)",&answ );
  }
}

int   main ( int argc,char* argv[] )
{
  int   size;
  int   answ=NO;

  if( GetFileSize( USB_DIR DAT_FILE,&size )==OK )
    ShowNavigationQuestionScreen( "WRITE user_cofig.dat ?",&answ );

  if( answ==YES )
  {
    UPGCopy( USB_DIR DAT_FILE,RTX_DIR DAT_FILE,0 );
    UPGCopy( USB_DIR INF_FILE,RTX_DIR INF_FILE,0 );
/*
    UPGCopy( USB_DIR DAT_FILE,FLASH_DIR DAT_FILE,0 );
    UPGCopy( USB_DIR INF_FILE,FLASH_DIR INF_FILE,0 );
*/
    BackupDBSystem();
    SetSBSystemCodeVIN();

    ShowNavigationQuestionScreen( "Files copied. Reboot ?",&answ );
    if( answ==YES )
      RebootSystem();
  }
  else
  {
    ShowNavigationQuestionScreen( "READ user_config.dat ?",&answ );
    if( answ==YES )
    {
      UPGCopy( RTX_DIR DAT_FILE,USB_DIR DAT_FILE,0 );
      UPGCopy( RTX_DIR INF_FILE,USB_DIR INF_FILE,0 );

      BackupDBSystem();

      ShowNavigationQuestionScreen( "Copy completed.",&answ );
    }
    else
      ShowNavigationQuestionScreen( "Finish.",&answ );
  }
  return OK;
}
